const TransformPages = require('uni-read-pages')
const { webpack } = new TransformPages()
const UnoCSS = require('unocss-webpack-uniapp2').default
module.exports = {
  // productionSourceMap: false,
  lintOnSave: process.env.NODE_ENV === 'development',
  transpileDependencies: ['uview-ui', 'luch-request', '@dcloudio/uni-ui'], // 需要babel-loader转义的第三方依赖, 指定需要编译的依赖
  configureWebpack: {
    plugins: [
      new webpack.DefinePlugin({
        ROUTES: webpack.DefinePlugin.runtimeValue(() => {
          const tfPages = new TransformPages({
            includes: ['path', 'name', 'meta', 'aliasPath']
          })
          return JSON.stringify(tfPages.routes)
        }, true)
      }),
      UnoCSS()
    ]
  }
}
